
function readonly(target: Object, propertyName: string, descriptor: PropertyDescriptor) {
    console.log(target);
    console.log(propertyName);
    console.log(descriptor);
    descriptor.writable = false;
}

function logger(target: Object, method: string, descriptor: PropertyDescriptor) {

    let original = descriptor.value;
        
    descriptor.value = function(...args) {
        
        //logging
        console.log(JSON.stringify(args));

        let returnValue = original.apply(this, args);

        ///logging
        console.log('Return -' + returnValue);

        return returnValue;

    }

}


function format(target: Object, propertyName: string) {
    let value = this[propertyName];

    let getter = function() {
        return "Mr." + value;
    }

    let setter = function(newvalue) {
        value = newvalue;
    }

    if(delete this[propertyName]) {
        Object.defineProperty(target, propertyName, {
            get: getter,
            set: setter
        });
    }
}


class User {
    
    @format
    name: string;

    constructor(name:string) {
            this.name = name;
    }


    @readonly
    getName():void {
        console.log(this.name);
    }


    @logger
    calc(hours: number, stavka: number) : number {
        return hours * stavka;
    }
}

let Ben = new User('Ben');
Ben.getName = function() {
    console.log('hello');
}

Ben.getName();

Ben.calc(120, 100);

console.log(Ben.name);
Ben.name = "John";
console.log(Ben.name);